/*****************************************************************************
* | File      	:   EPD_5in83b_V2_test.c
* | Author      :   Waveshare team
* | Function    :   5.83inch B V2 e-paper test demo
* | Info        :
*----------------
* |	This version:   V1.0
* | Date        :   2020-07-04
* | Info        :
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documnetation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to  whom the Software is
# furished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS OR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
******************************************************************************/
#include "EPD_Test.h"
#include "EPD_5in83b_V2.h"
#include "ImageData.h"

int EPD_5in83b_V2_test(void)
{
    printf("EPD_5in83b_V2_test Demo\r\n");
    DEV_Module_Init();

    printf("e-Paper Init and Clear...\r\n");
    EPD_5IN83B_V2_Init();
    EPD_5IN83B_V2_Clear();
    DEV_Delay_ms(500);

    //Create a new image cache named IMAGE_BW and fill it with white
    UBYTE *BlackImage;
    UWORD Imagesize = ((EPD_5IN83B_V2_WIDTH % 8 == 0)? (EPD_5IN83B_V2_WIDTH / 8 ): (EPD_5IN83B_V2_WIDTH / 8 + 1)) * EPD_5IN83B_V2_HEIGHT;
    if((BlackImage = (UBYTE *)malloc(Imagesize / 4)) == NULL) {
        printf("Failed to apply for black memory...\r\n");
        return -1;
    }

    printf("NewImage:BlackImage \r\n");
    Paint_NewImage(BlackImage, EPD_5IN83B_V2_WIDTH, EPD_5IN83B_V2_HEIGHT / 4, 0, WHITE);

#if 1
    EPD_5IN83B_V2_Display(gImage_5in83b_V2_b, gImage_5in83b_V2_r);
	DEV_Delay_ms(5000);
#endif
		
#if 1   // Drawing on the image
    /*Horizontal screen*/
    //1.Draw black image
	Paint_Clear(WHITE);
	Paint_DrawPoint(10, 10, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
	Paint_DrawPoint(10, 20, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
	Paint_DrawPoint(10, 30, BLACK, DOT_PIXEL_3X3, DOT_STYLE_DFT);
	Paint_DrawString_EN(30, 0, "waveshare", &Font16, BLACK, WHITE);    
	Paint_DrawString_CN(150, 0, "΢ѩ", &Font24CN, WHITE, BLACK);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 0);
	
	Paint_Clear(WHITE);
	Paint_DrawLine(20, 1, 70, 50, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
	Paint_DrawLine(70, 1, 20, 50, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);      
	Paint_DrawRectangle(20, 1, 70, 50, BLACK, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
	Paint_DrawRectangle(80, 1, 130, 50, BLACK, DOT_PIXEL_1X1, DRAW_FILL_FULL);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 1);
	
	Paint_Clear(WHITE);
	Paint_DrawCircle(210, 21, 20, BLACK, DOT_PIXEL_1X1, DRAW_FILL_FULL);
	Paint_DrawLine(140, 21, 180, 21, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
	Paint_DrawLine(210, 1, 210, 41, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
	Paint_DrawNum(10, 1, 987654321, &Font16, WHITE, BLACK);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 2);
	
	Paint_Clear(BLACK);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 3);		
	
	//2.Draw red image
	Paint_Clear(WHITE);
	Paint_DrawPoint(334, 10, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
	Paint_DrawPoint(334, 20, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
	Paint_DrawPoint(334, 30, BLACK, DOT_PIXEL_3X3, DOT_STYLE_DFT);
	Paint_DrawString_EN(354, 0, "waveshare", &Font16, BLACK, WHITE);    
	Paint_DrawString_CN(474, 0, "΢ѩ", &Font24CN, WHITE, BLACK);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 4);
	
	Paint_Clear(WHITE);
	Paint_DrawLine(344, 1, 394, 50, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
	Paint_DrawLine(394, 1, 344, 50, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);      
	Paint_DrawRectangle(344, 1, 394, 50, BLACK, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
	Paint_DrawRectangle(404, 1, 454, 50, BLACK, DOT_PIXEL_1X1, DRAW_FILL_FULL);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 5);
	
	Paint_Clear(WHITE);
	Paint_DrawCircle(534, 21, 20, BLACK, DOT_PIXEL_1X1, DRAW_FILL_FULL);
	Paint_DrawLine(464, 21, 504, 21, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
	Paint_DrawLine(534, 1, 534, 41, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
	Paint_DrawNum(334, 1, 987654321, &Font16, WHITE, BLACK);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 6);
	
	Paint_Clear(WHITE);
	Paint_DrawRectangle(324, 0, 648, 120, BLACK, DOT_PIXEL_1X1, DRAW_FILL_FULL);
	EPD_5IN83B_V2_DisplayPicture(BlackImage, 7);	
	
	DEV_Delay_ms(5000);
#endif
    printf("Clear...\r\n");
    EPD_5IN83B_V2_Clear();

    printf("Goto Sleep...\r\n");
    EPD_5IN83B_V2_Sleep();
    free(BlackImage);
    BlackImage = NULL;

    // close 5V
    printf("close 5V, Module enters 0 power consumption ...\r\n");
    DEV_Module_Exit();
    
    return 0;
}

